HelpBot Assistant

How can I help you?

Virtualization in EJ2 JavaScript ListView control

22 Feb 202521 minutes to read

UI virtualization loads only the viewable list items within a viewport, significantly improving ListView performance when dealing with a large amount of data.

Module injection

To use UI virtualization, you should import the Virtualization module from the ej2-lists package and inject it using the ListView.Inject() method, as shown in the following code snippet.

import { ListView, Virtualization } from '@syncfusion/ej2-lists';

ListView.Inject(Virtualization);

UI virtualization can be enabled in the ListView by setting the enableVirtualization property to true.

There are two types of scroll behaviors:

Window Scroll: This is used by default in the ListView.

Container Scroll: This is used when the height property of the ListView is set.

var listData = [
    { text: 'Nancy', id: '0', },
    { text: 'Andrew', id: '1' },
    { text: 'Janet', id: '2' },
    { text: 'Margaret', id: '3' },
    { text: 'Steven', id: '4' },
    { text: 'Laura', id: '5' },
    { text: 'Robert', id: '6' },
    { text: 'Michael', id: '7' },
    { text: 'Albert', id: '8' },
    { text: 'Nolan', id: '9' }
];

for (var i = 10; i <= 1010; i++) {
    var index = parseInt((Math.random() * 10).toString());
    listData.push({ text: listData[index].text, id: i.toString() });
}

var listObj = new ej.lists.ListView({

    //Set defined data to dataSource property.
    dataSource: listData,
    //Set height
    height: 500,
    //enable UI virtualization
    enableVirtualization: true,
});

listObj.appendTo('#ui-list');
<!DOCTYPE html>
<html lang="en">

<head>
    <title>Essential JS 2 for ListView </title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Essential JS 2 for ListView UI Control">
    <meta name="author" content="Syncfusion">
    <link href="https://cdn.syncfusion.com/ej2/32.2.3/ej2-base/styles/bootstrap5.3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/32.2.3/ej2-lists/styles/bootstrap5.3.css" rel="stylesheet">
    <link href="index.css" rel="stylesheet">
    <script src="https://cdn.syncfusion.com/ej2/32.2.3/dist/ej2.min.js" type="text/javascript"></script>
<script src="https://cdn.syncfusion.com/ej2/syncfusion-helper.js" type ="text/javascript"></script>
</head>

<body>
    <div id="container">
        <div id="ui-list"></div>
    </div>

    <script>
        var ele = document.getElementById('container');
        if (ele) {
            ele.style.visibility = "visible";
        }   
    </script>
    <script src="index.js" type="text/javascript"></script>
    <style>
        #ui-list {
            display: block;
            max-width: 350px;
            margin: auto;
            border-radius: 3px;
            cursor: pointer;
        }
    </style>
</body>

</html>
#container {
    visibility: hidden;
}

#loader {
  color: #008cff;
  height: 40px;
  width: 30%;
  position: absolute;
  font-family: 'Helvetica Neue','calibiri';
  font-size: 14px;
  top: 45%;
  left: 45%;
}

You can use the template property to customize list items in UI virtualization.

var listData = [
    { name: 'Nancy', icon: 'N', id: '0', },
    { name: 'Andrew', icon: 'A', id: '1' },
    { name: 'Janet', icon: 'J', id: '2' },
    { name: 'Margaret', imgUrl: '//ej2.syncfusion.com/demos/src/listview/images/margaret.png', id: '3' },
    { name: 'Steven', icon: 'S', id: '4' },
    { name: 'Laura', imgUrl: '//ej2.syncfusion.com/demos/src/listview/images/laura.png', id: '5' },
    { name: 'Robert', icon: 'R', id: '6' },
    { name: 'Michael', icon: 'M', id: '7' },
    { name: 'Albert', imgUrl: '//ej2.syncfusion.com/demos/src/listview/images/albert.png', id: '8' },
    { name: 'Nolan', icon: 'N', id: '9' }
]
for (var i = 10; i <= 1010; i++) {
    var index = parseInt((Math.random() * 10).toString());
    listData.push({ name: listData[index].name, icon: listData[index].icon, imgUrl: listData[index].imgUrl, id: i.toString() });
}
var template = function (data) {
    var showIcon = data.imgUrl ? 'hideUI' : 'showUI';
    var showImg = data.imgUrl ? 'showUI' : 'hideUI';
    var imgUrl = data.imgUrl || '';
    var result = '<div class="e-list-wrapper e-list-avatar">' +
        '<span class="e-avatar e-avatar-circle ' + data.icon + ' ' + showIcon + '">' + data.icon + '</span>' +
        '<img class="e-avatar e-avatar-circle ' + showImg + '" src="' + imgUrl + '" />' +
        '<span class="e-list-content">' + data.name + '</span>' +
        '</div>';
    return result;
};
var listObj = new ej.lists.ListView({

    //Set defined data to dataSource property.
    dataSource: listData,

    //enable UI virtualization
    enableVirtualization: true,

    //Set height
    height: 500,

    //Set header title
    headerTitle: 'Contacts',

    //Set true to show header title
    showHeader: true,

    //Set defined customized css class
    cssClass: 'e-list-template',

    //Set defined customized template
    template: template
});

listObj.appendTo('#ui-list');
<!DOCTYPE html>
<html lang="en">

<head>
    <title>Essential JS 2 for ListView </title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Essential JS 2 for ListView UI Control">
    <meta name="author" content="Syncfusion">
    <link href="https://cdn.syncfusion.com/ej2/32.2.3/ej2-base/styles/bootstrap5.3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/32.2.3/ej2-lists/styles/bootstrap5.3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/32.2.3/ej2-layouts/styles/bootstrap5.3.css" rel="stylesheet" />
    <link href="index.css" rel="stylesheet">
    <script src="https://cdn.syncfusion.com/ej2/32.2.3/dist/ej2.min.js" type="text/javascript"></script>
<script src="https://cdn.syncfusion.com/ej2/syncfusion-helper.js" type ="text/javascript"></script>
</head>

<body>
    <div id="container">
        <div id="ui-list"></div>
    </div>

    <script>
        var ele = document.getElementById('container');
        if (ele) {
            ele.style.visibility = "visible";
        }   
    </script>
    <script src="index.js" type="text/javascript"></script>
    <style>
        #ui-list.e-listview {
            margin: auto;
            max-width: 325px;
            line-height: initial;
            border: 1px solid lightgray;
        }

        #ui-list.e-listview .e-list-header {
            height: 50px
        }

        #ui-list.e-listview .e-list-header .e-text {
            line-height: 18px
        }

        #ui-list.e-listview .R {
            background: lightgrey;
        }

        #ui-list.e-listview .M {
            background: pink;
        }

        #ui-list.e-listview .A {
            background: lightgreen;
        }

        #ui-list.e-listview .S {
            background: lightskyblue;
        }

        #ui-list.e-listview .J {
            background: orange;
        }

        #ui-list.e-listview .N {
            background: lightblue;
        }

        #ui-list.e-listview .e-list-item {
            padding: 3px 0;
        }

        #ui-list .list-container {
            width: inherit;
            height: 100%;

        }

        #ui-list.e-listview .showUI {
            display: flex;
        }

        #ui-list.e-listview .hideUI {
            display: none;
        }
    </style>
</body>

</html>
#container {
    visibility: hidden;
}

#loader {
    color: #008cff;
    height: 40px;
    width: 30%;
    position: absolute;
    font-family: 'Helvetica Neue','calibiri';
    font-size: 14px;
    top: 45%;
    left: 45%;
  }

Conditional rendering

The following conditional rendering support is provided for the template and groupTemplate.

Name Syntax
conditional rendering ${if(id % 2=="0")}<div id="list-container" class="even-list"> ${text} </div>${else}<div id="list-container" class="odd-list"> ${text} </div>${/if}

In the following sample, the light blue is applied for the even list and light coral is applied for the odd list based on the conditional class.

var listData = [];

listData = [
    { text: 'Nancy', id: '0', },
    { text: 'Andrew', id: '1' },
    { text: 'Janet', id: '2' },
    { text: 'Margaret', id: '3' },
    { text: 'Steven', id: '4' },
    { text: 'Laura', id: '5' },
    { text: 'Robert', id: '6' },
    { text: 'Michael', id: '7' },
    { text: 'Albert', id: '8' },
    { text: 'Nolan', id: '9' }
];

for (var i = 10; i <= 1010; i++) {
    var index = parseInt((Math.random() * 10).toString());
    listData.push({ text: listData[index].text, id: i.toString() });
}

var listObj = new ej.lists.ListView({

    //Set defined data to dataSource property.
    dataSource: listData,

    //enable UI virtualization
    enableVirtualization: true,

    //Set height
    height: 380,

    //Set defined customized template
    template: '${if(id % 2=="0")}<div id="list-container" class="even-list"> ${text} </div>${else}<div id="list-container" class="odd-list"> ${text} </div>${/if}'
});

listObj.appendTo('#ui-list');
<!DOCTYPE html>
<html lang="en">

<head>
    <title>Essential JS 2 for ListView </title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Essential JS 2 for ListView UI Control">
    <meta name="author" content="Syncfusion">
    <link href="https://cdn.syncfusion.com/ej2/32.2.3/ej2-base/styles/bootstrap5.3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/32.2.3/ej2-lists/styles/bootstrap5.3.css" rel="stylesheet">
    <link href="index.css" rel="stylesheet">
    <script src="https://cdn.syncfusion.com/ej2/32.2.3/dist/ej2.min.js" type="text/javascript"></script>
<script src="https://cdn.syncfusion.com/ej2/syncfusion-helper.js" type ="text/javascript"></script>
</head>

<body>
    <div id="container">
        <div id="ui-list"></div>
    </div>

    <script>
        var ele = document.getElementById('container');
        if (ele) {
            ele.style.visibility = "visible";
        }   
    </script>
    <script src="index.js" type="text/javascript"></script>
    <style>
        #ui-list {
            display: block;
            max-width: 350px;
            margin: auto;
            border: 1px solid #dddddd;
            border-radius: 3px;
            cursor: pointer;
        }

        #list-container {
            height: inherit;
            width: inherit;
            padding-left: 30px;
        }

        #ui-list .e-list-item {
            padding: 0;
        }

        #ui-list .even-list {
            background-color: #cfd8dc;
        }

        #ui-list .odd-list {
            background-color: #eceff1;
        }
    </style>
</body>

</html>
#container {
    visibility: hidden;
}

#loader {
  color: #008cff;
  height: 40px;
  width: 30%;
  position: absolute;
  font-family: 'Helvetica Neue','calibiri';
  font-size: 14px;
  top: 45%;
  left: 45%;
}

Virtualization in Angular Listview component

27 Sep 20239 minutes to read

UI virtualization loads only viewable list items in a view port which will increase ListView performance on loading large number of data.

Module injection

In order to use UI Virtualization, we need to import VirtualizationService module in the AppModule and it should be injected to the provider section as follow

import { NgModule } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import { ListViewModule, VirtualizationService } from '@syncfusion/ej2-angular-lists';

/**
 * Module
 */
@NgModule({
    imports: [
        BrowserModule,
        ListViewModule
    ],
    declarations: [AppComponent],
    bootstrap: [AppComponent],
    providers: [VirtualizationService]
})
export class AppModule { }

Getting started

UI virtualization can be enabled in ListView by setting enableVirtualization property to true.

It has two type of scroller

Window scroll - This scroller is used in ListView by default.

Container scroll - This will be used, if the height property of ListView was set.

import { Component } from '@angular/core';

@Component({
    selector: 'my-app',
    template: `<ejs-listview id='ui-list' [dataSource]='listData' [enableVirtualization]='true' ></ejs-listview>`
})

export class AppComponent {
    public listData: { [key: string]: string | object }[] = [
        { text: 'Nancy', id: '0', },
        { text: 'Andrew', id: '1' },
        { text: 'Janet', id: '2' },
        { text: 'Margaret', id: '3' },
        { text: 'Steven', id: '4' },
        { text: 'Laura', id: '5' },
        { text: 'Robert', id: '6' },
        { text: 'Michael', id: '7' },
        { text: 'Albert', id: '8' },
        { text: 'Nolan', id: '9' }
    ];

    public ngOnInit() {
        for (let i: number = 10; i <= 1010; i++) {
            let index: number = parseInt((Math.random() * 10).toString());
            this.listData.push({ text: (this.listData[index] as any).text, id: i.toString() });
        }
    }
}
import { NgModule } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import { ListViewModule, VirtualizationService } from '@syncfusion/ej2-angular-lists';

/**
 * Module
 */
@NgModule({
    imports: [
        BrowserModule,
        ListViewModule
    ],
    declarations: [AppComponent],
    bootstrap: [AppComponent],
    providers: [VirtualizationService]
})
export class AppModule { }
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { enableProdMode } from '@angular/core';
import { AppModule } from './app.module';

import 'zone.js';
enableProdMode();
platformBrowserDynamic().bootstrapModule(AppModule);

We can use ng-template property to customize list items in UI virtualization.

import { Component } from '@angular/core';

@Component({
    selector: 'my-app',
    template: `<ejs-listview id='ui-list' [dataSource]='listData' [enableVirtualization]='true' [height]=500 headerTitle='Contacts' [showHeader]='true'>
    <ng-template #template let-data="">
        <div class="list-container">
        <div id="icon" *ngIf="data.icon !== ''" class=>
            <span class="showUI"></span>
            <img class="hideUI" width = '45' height = '45' src= />
        </div>
        <div id="icon" *ngIf="data.imgUrl !== ''" class="img">
            <span class="hideUI"></span>
            <img class="showUI" width = '45' height = '45' src= />
        </div>
        <div class="name"></div>
        </div>
  </ng-template>
  </ejs-listview>`
})

export class AppComponent {
   public listData: { [key: string]: string | object }[] = [
    { name: 'Nancy', icon: 'N', imgUrl:'', id: '0', },
    { name: 'Andrew', icon: 'A', imgUrl:'', id: '1' },
    { name: 'Janet', icon: 'J', imgUrl:'', id: '2' },
    { name: 'Margaret', icon: '', imgUrl: 'https://ej2.syncfusion.com/demos/src/grid/images/2.png', id: '3' },
    { name: 'Steven', icon: 'S', imgUrl:'', id: '4' },
    { name: 'Laura', icon: '', imgUrl: 'https://ej2.syncfusion.com/demos/src/grid/images/3.png', id: '5' },
    { name: 'Robert', icon: 'R', imgUrl:'', id: '6' },
    { name: 'Michael', icon: 'M', imgUrl:'', id: '7' },
    { name: 'Albert', icon: '', imgUrl: 'https://ej2.syncfusion.com/demos/src/grid/images/5.png', id: '8' },
    { name: 'Nolan', icon: 'N', imgUrl:'', id: '9' }
];

public ngOnInit() {
    for (let i: number = 10; i <= 1010; i++) {
        let index: number = parseInt((Math.random() * 10).toString());
        this.listData.push({ name: (this.listData[index] as any).name, icon: (this.listData[index] as any).icon, imgUrl: (this.listData[index] as any).imgUrl, id: i.toString() });
    }
}
}
import { NgModule } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import { ListViewModule, VirtualizationService } from '@syncfusion/ej2-angular-lists';

/**
 * Module
 */
@NgModule({
    imports: [
        BrowserModule,
        ListViewModule
    ],
    declarations: [AppComponent],
    bootstrap: [AppComponent],
    providers: [VirtualizationService]
})
export class AppModule { }
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { enableProdMode } from '@angular/core';
import { AppModule } from './app.module';

import 'zone.js';
enableProdMode();
platformBrowserDynamic().bootstrapModule(AppModule);

HelpBot Assistant

How can I help you?

Virtualization in Vue ListView component

12 Mar 202524 minutes to read

UI virtualization loads only viewable list items in a view port, which will improve the ListView performance while loading a large number of data.

Module injection

In order to use UI Virtualization, virtualization module should be injected into the provide section and use listview as a key of the object.

export default {
  data: function() {
    return {
      listData: listData,
      enableUi: true
    };
  },
  provide: {
    listview: [Virtualization]
  }
}

Enable Virtualization

UI virtualization can be enabled in the ListView by setting the enableVirtualization property to true.

It has two types of scrollers as follows:

Window scroll: This scroller is used in the ListView by default.

Container scroll: This scroller is used, when the height property of the ListView is set.

<template>
  <div class="control-section">
    <ejs-listview id='ui-list' :dataSource='listData' :height="height" :enableVirtualization='enableUi'>
    </ejs-listview>
  </div>
</template>

<script setup>
import { provide, onBeforeMount } from "vue";

import { ListViewComponent as EjsListview, Virtualization } from "@syncfusion/ej2-vue-lists";

let listData = [];

onBeforeMount(() => {
  listData = [
    { text: "Nancy", id: "0" },
    { text: "Andrew", id: "1" },
    { text: "Janet", id: "2" },
    { text: "Margaret", id: "3" },
    { text: "Steven", id: "4" },
    { text: "Laura", id: "5" },
    { text: "Robert", id: "6" },
    { text: "Michael", id: "7" },
    { text: "Albert", id: "8" },
    { text: "Nolan", id: "9" }
  ];

  for (let i = 10; i <= 1000; i++) {
    let index = parseInt((Math.random() * 10).toString());
    listData.push({ text: listData[index].text, id: i.toString() });
  }
});

const enableUi = true;
const height = "330px";
provide('listview', [Virtualization]);

</script>
<style>
#app {
  color: #008cff;
  height: 40px;
  left: 30%;
}

#ui-list {
  display: block;
  max-width: 400px;
  margin: auto;
  border-radius: 3px;
  cursor: pointer;
}
</style>
<template>
  <div class="control-section">
    <ejs-listview id='ui-list' :dataSource='listData' :height="height" :enableVirtualization='enableUi'>
    </ejs-listview>
  </div>
</template>

<script>

import { ListViewComponent, Virtualization } from "@syncfusion/ej2-vue-lists";

let listData = [];

export default {
  name: "App",
  components: {
    "ejs-listview": ListViewComponent
  },

  beforeCreate: function () {
    listData = [
      { text: "Nancy", id: "0" },
      { text: "Andrew", id: "1" },
      { text: "Janet", id: "2" },
      { text: "Margaret", id: "3" },
      { text: "Steven", id: "4" },
      { text: "Laura", id: "5" },
      { text: "Robert", id: "6" },
      { text: "Michael", id: "7" },
      { text: "Albert", id: "8" },
      { text: "Nolan", id: "9" }
    ];

    for (let i = 10; i <= 1000; i++) {
      let index = parseInt((Math.random() * 10).toString());
      listData.push({ text: listData[index].text, id: i.toString() });
    }
  },
  data: function () {
    return {
      listData: listData,
      enableUi: true,
      height: "330px"
    };
  },
  provide: {
    listview: [Virtualization]
  }
};
</script>
<style>
#app {
  color: #008cff;
  height: 40px;
  left: 30%;
}

#ui-list {
  display: block;
  max-width: 400px;
  margin: auto;
  border-radius: 3px;
  cursor: pointer;
}
</style>

Template

We can use template property to customize list items in UI virtualization.

<template>
    <div class="control-section">
      <ejs-listview id='ui-list' ref="list" :dataSource='listData' :showHeader='header' :fields='fields'
        :headerTitle='title' :height='height' :cssClass='cssClass' :enableVirtualization='enableUi'
        :template="'gTemplate'">
        <template v-slot:gTemplate="{ data }">
          <div class="e-list-wrapper e-list-avatar">
            <span :class="['e-avatar e-avatar-circle ' + data.icon + ' showUI']" v-if="data.imgUrl == undefined"></span>
            <span :class="['e-avatar e-avatar-circle ' + data.icon + ' hideUI']" v-if="data.imgUrl !== undefined"></span>
            <img :class="['e-avatar e-avatar-circle showUI']" :src="data.imgUrl" v-if="data.imgUrl !== undefined" />
            <img :class="['e-avatar e-avatar-circle hideUI']" :src="data.imgUrl" v-if="data.imgUrl == undefined" />
            <span class="e-list-content"></span>
          </div>
        </template>
      </ejs-listview>
    </div>
  </template>
  
  <script setup>
  import { provide, onBeforeMount } from "vue";
  
  import { ListViewComponent as EjsListview, Virtualization } from "@syncfusion/ej2-vue-lists";
  
  let listData = [];
  
  
  onBeforeMount(() => {
    listData = [
      { name: 'Nancy', icon: 'N', id: '0', },
      { name: 'Andrew', icon: 'A', id: '1' },
      { name: 'Janet', icon: 'J', id: '2' },
      { name: 'Margaret', imgUrl: 'https://ej2.syncfusion.com/react/demos/src/listview/images/margaret.png', id: '3' },
      { name: 'Steven', icon: 'S', id: '4' },
      { name: 'Laura', imgUrl: 'https://ej2.syncfusion.com/react/demos/src/listview/images/laura.png', id: '5' },
      { name: 'Robert', icon: 'R', id: '6' },
      { name: 'Michael', icon: 'M', id: '7' },
      { name: 'Albert', imgUrl: 'https://ej2.syncfusion.com/react/demos/src/listview/images/albert.png', id: '8' },
      { name: 'Nolan', icon: 'N', id: '9' }
    ];
  
    for (let i = 10; i <= 1000; i++) {
      let index = parseInt((Math.random() * 10).toString());
      listData.push({ name: listData[index].name, icon: listData[index].icon, imgUrl: listData[index].imgUrl, id: i.toString() });
    }
  });
  
  const header = true;
  const title = "Contacts";
  const fields = { text: "name" };
  const height = 330;
  const cssClass = 'e-list-template';
  const enableUi = true;
  
  provide('listview', [Virtualization]);
  
  </script>
  <style>
  @import "../node_modules/@syncfusion/ej2-base/styles/material3.css";
  @import "../node_modules/@syncfusion/ej2-buttons/styles/material3.css";
  @import "../node_modules/@syncfusion/ej2-vue-lists/styles/material3.css";
  
  #app {
    color: #008cff;
    height: 40px;
    left: 30%;
  }
  
  #ui-list.e-listview {
    margin: auto;
    max-width: 325px;
    line-height: initial;
    border: 1px solid lightgray;
  }
  
  /* ListView header alignment */
  
  #ui-list.e-listview .e-list-header {
    height: 50px
  }
  
  #ui-list.e-listview .e-list-header .e-text {
    line-height: 18px
  }
  
  /* ListView template customization */
  
  #ui-list.e-listview .showUI {
    display: flex;
    align-items: center;
    justify-content: center;
    border-radius: 50%;
  }
  
  #ui-list.e-listview .hideUI {
    display: none;
  }
  
  #ui-list.e-listview .e-list-item {
    padding: 3px 0;
  }
  
  #ui-list.e-listview .R {
    background: lightgrey;
  }
  
  #ui-list.e-listview .M {
    background: pink;
  }
  
  #ui-list.e-listview .A {
    background: lightgreen;
  }
  
  #ui-list.e-listview .S {
    background: lightskyblue;
  }
  
  #ui-list.e-listview .J {
    background: orange;
  }
  
  #ui-list.e-listview .N {
    background: lightblue;
  }
  </style>
<template>
    <div class="control-section">     
      <ejs-listview id='ui-list' ref="list" :dataSource='listData' :showHeader='header' :fields='fields' :headerTitle='title'
          :height='height' :cssClass='cssClass' :enableVirtualization='enableUi' :template="'gTemplate'">
              <template v-slot:gTemplate="{ data }">
                  <div class="e-list-wrapper e-list-avatar" >
                      <span :class="['e-avatar e-avatar-circle ' + data.icon + ' showUI']" v-if="data.imgUrl == undefined"></span>
                      <span :class="['e-avatar e-avatar-circle ' + data.icon + ' hideUI']" v-if="data.imgUrl !== undefined"></span> 
                      <img :class="['e-avatar e-avatar-circle showUI']" :src="data.imgUrl" v-if="data.imgUrl !== undefined" />
                      <img :class="['e-avatar e-avatar-circle hideUI']" :src="data.imgUrl" v-if="data.imgUrl == undefined" />
                      <span class="e-list-content"></span>
                  </div>
              </template>
          </ejs-listview>
    </div>
  </template>
  
  <script>
  
  import { ListViewComponent, Virtualization } from "@syncfusion/ej2-vue-lists";
  
  let listData = [];
  
  export default {
  name: "App",
  components: {
  "ejs-listview":ListViewComponent
  },
  
      beforeCreate: function() {
  listData = [
      { name: 'Nancy', icon: 'N', id: '0', },
      { name: 'Andrew', icon: 'A', id: '1' },
      { name: 'Janet', icon: 'J', id: '2' },
      { name: 'Margaret', imgUrl: 'https://ej2.syncfusion.com/react/demos/src/listview/images/margaret.png', id: '3' },
      { name: 'Steven', icon: 'S', id: '4' },
      { name: 'Laura', imgUrl: 'https://ej2.syncfusion.com/react/demos/src/listview/images/laura.png', id: '5' },
      { name: 'Robert', icon: 'R', id: '6' },
      { name: 'Michael', icon: 'M', id: '7' },
      { name: 'Albert', imgUrl: 'https://ej2.syncfusion.com/react/demos/src/listview/images/albert.png', id: '8' },
      { name: 'Nolan', icon: 'N', id: '9' }
  ];
  
  for (let i = 10; i <= 1000; i++) {
      let index = parseInt((Math.random() * 10).toString());
      listData.push({ name: listData[index].name, icon: listData[index].icon, imgUrl: listData[index].imgUrl, id: i.toString() });
  }
  },
    data: function() {
      return {
        listData: listData,     
        header: true,
        title: "Contacts",
        fields: { text: "name" },
        height: 330,
        cssClass:'e-list-template',
        enableUi: true,
      };
    },
    provide: {
      listview: [Virtualization]
    }
  }
  </script>
  <style>
  @import "../node_modules/@syncfusion/ej2-base/styles/material3.css";
  @import "../node_modules/@syncfusion/ej2-buttons/styles/material3.css";
  @import "../node_modules/@syncfusion/ej2-vue-lists/styles/material3.css";
  #app {
      color: #008cff;
      height: 40px;
      left: 30%;
  }
  
  #ui-list.e-listview {
          margin: auto;
          max-width: 325px;
          line-height: initial;
          border: 1px solid lightgray;
      }
  
      /* ListView header alignment */
  
      #ui-list.e-listview .e-list-header {
          height: 50px
      }
  
      #ui-list.e-listview .e-list-header .e-text {
          line-height: 18px
      }
  
      /* ListView template customization */
  
      #ui-list.e-listview .showUI {
          display: flex;
          align-items: center;
          justify-content: center;
          border-radius: 50%;
      }
      #ui-list.e-listview .hideUI {
          display: none;
      }
  
      #ui-list.e-listview .e-list-item {
          padding: 3px 0;
      }
  
      #ui-list.e-listview .R {
          background: lightgrey;
      }
  
      #ui-list.e-listview .M {
          background: pink;
      }
  
      #ui-list.e-listview .A {
          background: lightgreen;
      }
  
      #ui-list.e-listview .S {
          background: lightskyblue;
      }
  
      #ui-list.e-listview .J {
          background: orange;
      }
  
      #ui-list.e-listview .N {
          background: lightblue;
      }
  </style>

Conditional rendering

The following conditional rendering support is provided for the template and groupTemplate.

Name Syntax
conditional class <div class="${ $id % 2 === 0 ? 'even-list' : 'odd-list'}"></div>
conditional attribute <div id="${ $id % 2 === 0 ? 'even-list' : 'odd-list'}"></div>
conditional text content <div>${ $id % 2 === 0 ? 'even-list' : 'odd-list'}</div>

In the following sample, the light blue is applied for the even list and light coral is applied for the odd list based on the conditional class.

<template>
  <div class="control-section">
    <ejs-listview id='ui-list' :dataSource='listData' :enableVirtualization='enableUi' :template='gTemplate'
      :height='height'>
    </ejs-listview>
  </div>
</template>

<script setup>
import { provide } from "vue";
import { onBeforeMount } from "vue";
import { ListViewComponent as EjsListview, Virtualization } from "@syncfusion/ej2-vue-lists";

let listData = [];

onBeforeMount(() => {
  listData = [
    { text: 'Nancy', id: '0', },
    { text: 'Andrew', id: '1' },
    { text: 'Janet', id: '2' },
    { text: 'Margaret', id: '3' },
    { text: 'Steven', id: '4' },
    { text: 'Laura', id: '5' },
    { text: 'Robert', id: '6' },
    { text: 'Michael', id: '7' },
    { text: 'Albert', id: '8' },
    { text: 'Nolan', id: '9' }
  ];

  for (let i = 10; i <= 1000; i++) {
    let index = parseInt((Math.random() * 10).toString());
    listData.push({ text: listData[index].text, id: i.toString() });
  }
});

const gTemplate ='<div id="list-container" class="class-${parseInt(id) % 2}" > ${text} </div>';
const height = 500;
const enableUi = true;

provide('listview', [Virtualization]);

</script>

<style>
#app {
  color: #008cff;
  height: 40px;
  left: 30%;
  position: absolute;
}

#ui-list {
  display: block;
  max-width: 400px;
  margin: auto;
  border: 1px solid #dddddd;
  border-radius: 3px;
  cursor: pointer;
}

#list-container {
  height: inherit;
  width: inherit;
  padding-left: 30px;
}

#ui-list .e-list-item {
  padding: 0;
}

#ui-list .class-0 {
  background-color: lightblue;
}

#ui-list .class-1 {
  background-color: lightcoral;
}
</style>
<template>
  <div class="control-section">
    <ejs-listview id='ui-list' :dataSource='listData' :enableVirtualization='enableUi' :template='gTemplate'
      :height='height'>
    </ejs-listview>
  </div>
</template>

<script>

import { ListViewComponent, Virtualization } from "@syncfusion/ej2-vue-lists";

let listData = [];

export default {
  name: "App",
  components: {
    "ejs-listview": ListViewComponent
  },
  beforeCreate: function () {
    listData = [
      { text: 'Nancy', id: '0', },
      { text: 'Andrew', id: '1' },
      { text: 'Janet', id: '2' },
      { text: 'Margaret', id: '3' },
      { text: 'Steven', id: '4' },
      { text: 'Laura', id: '5' },
      { text: 'Robert', id: '6' },
      { text: 'Michael', id: '7' },
      { text: 'Albert', id: '8' },
      { text: 'Nolan', id: '9' }
    ];
     
    for (let i = 10; i <= 1000; i++) {
      let index = parseInt((Math.random() * 10).toString());
      listData.push({ text: listData[index].text, id: i.toString() });
    }
  },
  data: function () {
    return {
      listData: listData,
      gTemplate: '<div id="list-container" class="class-${parseInt(id) % 2}" > ${text} </div>',
      height: 500,
      enableUi: true,
    };
  },
  provide: {
    listview: [Virtualization]
  }
}
</script>
<style>
#app {
  color: #008cff;
  height: 40px;
  left: 30%;
  position: absolute;
}

#ui-list {
  display: block;
  max-width: 400px;
  margin: auto;
  border: 1px solid #dddddd;
  border-radius: 3px;
  cursor: pointer;
}

#list-container {
  height: inherit;
  width: inherit;
  padding-left: 30px;
}

#ui-list .e-list-item {
  padding: 0;
}

#ui-list .class-0 {
  background-color: lightblue;
}

#ui-list .class-1 {
  background-color: lightcoral;
}
</style>

Virtualization in React ListView component

23 Jan 202524 minutes to read

UI virtualization loads only the viewable list items in a viewport, which significantly improves ListView performance when loading a large number of data items.

Module injection

To use UI Virtualization, we need to inject its virtualization service in the App. This modules should be injected into the ListView using the Inject directive as like the below code snippet.

import { ListViewComponent, Inject, Virtualization } from '@syncfusion/ej2-react-lists';

....
....

return (
    // specifies the tag to render the ListView component
    <ListViewComponent id='ui-list' dataSource={listData} enableVirtualization={true} >
        <Inject services={[Virtualization]} />
    </ListViewComponent>
);
return (
// specifies the tag to render the ListView component
<ListViewComponent id='ui-list' dataSource={listData} enableVirtualization={true}>
              <Inject services={[Virtualization]}/>
          </ListViewComponent>);
export {};

Getting started

UI virtualization can be enabled in ListView by setting the enableVirtualization property to true. There are two types of scrollers available:

Window scroll - This scroller is used in ListView by default.

Container scroll - This will be used, if the height property of ListView was set.

import * as React from 'react';
import * as ReactDOM from "react-dom";
import { ListViewComponent, Inject, Virtualization } from '@syncfusion/ej2-react-lists';
function App() {
    // define the array of Json
    let listData;
    listData = [
        { text: "Nancy", id: "0" },
        { text: "Andrew", id: "1" },
        { text: "Janet", id: "2" },
        { text: "Margaret", id: "3" },
        { text: "Steven", id: "4" },
        { text: "Laura", id: "5" },
        { text: "Robert", id: "6" },
        { text: "Michael", id: "7" },
        { text: "Albert", id: "8" },
        { text: "Nolan", id: "9" }
    ];
    for (let i = 10; i <= 1010; i++) {
        let index = parseInt((Math.random() * 10).toString());
        listData.push({ text: listData[index].text, id: i.toString() });
    }
    let height="370px";
    return (
        // specifies the tag to render the ListView component
        <ListViewComponent id="ui-list" dataSource={listData} height={height} enableVirtualization={true}>
            <Inject services={[Virtualization]} />
        </ListViewComponent>);
}
export default App;
ReactDOM.render(<App />, document.getElementById('element'));
import * as React from 'react';
import * as ReactDOM from "react-dom";
import { ListViewComponent, Inject, Virtualization } from '@syncfusion/ej2-react-lists';

function App() {
  // define the array of Json
  let listData: { [key: string]: string | object }[];
  listData = [
    { text: "Nancy", id: "0" },
    { text: "Andrew", id: "1" },
    { text: "Janet", id: "2" },
    { text: "Margaret", id: "3" },
    { text: "Steven", id: "4" },
    { text: "Laura", id: "5" },
    { text: "Robert", id: "6" },
    { text: "Michael", id: "7" },
    { text: "Albert", id: "8" },
    { text: "Nolan", id: "9" }
  ];
  for (let i: number = 10; i <= 1010; i++) {
    let index: number = parseInt((Math.random() * 10).toString());
    listData.push({ text: listData[index].text, id: i.toString() });
  }
  let height="370px";

  return (
    // specifies the tag to render the ListView component
    <ListViewComponent id="ui-list" dataSource={listData} height={height} enableVirtualization={true}>
      <Inject services={[Virtualization]} />
    </ListViewComponent>
  );
}
export default App;
ReactDOM.render(<App />, document.getElementById('element'));
#ui-list {
  display: block;
  max-width: 400px;
  margin: auto;
  border-radius: 3px;
  cursor: pointer;
}
<!DOCTYPE html>
<html lang="en">

<head>
    <title>Syncfusion React ListView</title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <meta name="description" content="Essential JS 2 for React Components" />
    <meta name="author" content="Syncfusion" />
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-base/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-react-lists/styles/tailwind3.css" rel="stylesheet" />
    <link href="index.css" rel="stylesheet" />
    <script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.38/system.js"></script>
    <script src="systemjs.config.js"></script>
    <style>
        #loader {
            color: #008cff;
            height: 40px;
            left: 45%;
            position: absolute;
            top: 45%;
            width: 30%;
        }
    </style>
</head>

<body>
    <div id='element' style="margin:0 auto; max-width:400px;">
        <div id='loader'>Loading....</div>
    </div>
</body>

</html>

We can use template property to customize list items in UI virtualization.

import * as React from 'react';
import * as ReactDOM from "react-dom";
import { ListViewComponent, Inject, Virtualization } from '@syncfusion/ej2-react-lists';
import './index.css';
function App() {
  // define the array of Json
  let listData;
  listData = [
    { name: 'Nancy', icon: 'N', id: '0', },
    { name: 'Andrew', icon: 'A', id: '1' },
    { name: 'Janet', icon: 'J', id: '2' },
    { name: 'Margaret', imgUrl: 'https://ej2.syncfusion.com/react/demos/src/listview/images/margaret.png', id: '3' },
    { name: 'Steven', icon: 'S', id: '4' },
    { name: 'Laura', imgUrl: 'https://ej2.syncfusion.com/react/demos/src/listview/images/laura.png', id: '5' },
    { name: 'Robert', icon: 'R', id: '6' },
    { name: 'Michael', icon: 'M', id: '7' },
    { name: 'Albert', imgUrl: 'https://ej2.syncfusion.com/react/demos/src/listview/images/albert.png', id: '8' },
    { name: 'Nolan', icon: 'N', id: '9' }
  ];
  for (let i = 10; i <= 1010; i++) {
    let index = parseInt((Math.random() * 10).toString());
    listData.push({ name: listData[index].name, icon: listData[index].icon, imgUrl: listData[index].imgUrl, id: i.toString() });
  }
  function template(data) {
    return (
      <div className="e-list-wrapper e-list-avatar">
        <span className={`e-avatar e-avatar-small e-avatar-circle ${data.icon} ${data.imgUrl ? 'hideUI' : 'showUI'}`}>{data.icon}</span>
        <img className={`e-avatar e-avatar-circle ${data.imgUrl ? 'showUI' : 'hideUI'}`} src={data.imgUrl ? data.imgUrl : ' '} alt="" />
        <span className="e-list-content">{data.name}</span>
      </div>
    );
  } return (
    // specifies the tag to render the ListView component
    <ListViewComponent id='ui-list' dataSource={listData} enableVirtualization={true} template={template} cssClass='e-list-template' height={380} headerTitle="Contacts" showHeader={true}>
      <Inject services={[Virtualization]} />
    </ListViewComponent>);
}
export default App;
ReactDOM.render(<App />, document.getElementById('element'));
import * as React from 'react';
import * as ReactDOM from "react-dom";
import { ListViewComponent, Inject, Virtualization } from '@syncfusion/ej2-react-lists';

function App() {
    // define the array of Json
    let listData: { [key: string]: string | object }[];
    listData = [
        { name: 'Nancy', icon: 'N', id: '0', },
        { name: 'Andrew', icon: 'A', id: '1' },
        { name: 'Janet', icon: 'J', id: '2' },
        { name: 'Margaret', imgUrl: 'https://ej2.syncfusion.com/react/demos/src/listview/images/margaret.png', id: '3' },
        { name: 'Steven', icon: 'S', id: '4' },
        { name: 'Laura', imgUrl: 'https://ej2.syncfusion.com/react/demos/src/listview/images/laura.png', id: '5' },
        { name: 'Robert', icon: 'R', id: '6' },
        { name: 'Michael', icon: 'M', id: '7' },
        { name: 'Albert', imgUrl: 'https://ej2.syncfusion.com/react/demos/src/listview/images/albert.png', id: '8' },
        { name: 'Nolan', icon: 'N', id: '9' }
    ];
    for (let i: number = 10; i <= 1010; i++) {
        let index: number = parseInt((Math.random() * 10).toString());
        listData.push({ name: listData[index].name, icon: listData[index].icon, imgUrl: listData[index].imgUrl, id: i.toString() });
    }
    // Set customized list template
    function template(data: any) {
        return (
            <div className="e-list-wrapper e-list-avatar">
                <span className={`e-avatar e-avatar-circle ${data.icon} ${data.imgUrl ? 'hideUI' : 'showUI'}`}>{data.icon}</span>
                <img className={`e-avatar e-avatar-circle ${data.imgUrl ? 'showUI' : 'hideUI'}`} src={data.imgUrl ? data.imgUrl : ' '} />
                <span className="e-list-content">{data.name}</span>
            </div>
        );
    }
    return (
        // specifies the tag to render the ListView component
        <ListViewComponent id='ui-list' dataSource={listData} enableVirtualization={true} template={template} height={380} cssClass='e-list-template' headerTitle="Contacts" showHeader={true}>
            <Inject services={[Virtualization]} />
        </ListViewComponent>
    );
}
export default App;
ReactDOM.render(<App />, document.getElementById('element'));
#ui-list.e-listview {
    margin: auto;
    max-width: 325px;
    line-height: initial;
    border: 1px solid lightgray;
}

/* ListView header alignment */

#ui-list.e-listview .e-list-header {
    height: 50px
}

#ui-list.e-listview .e-list-header .e-text {
    line-height: 18px
}

/* ListView template customization */

#ui-list.e-listview .showUI {
    display: flex;
    align-items: center;
    justify-content: center;
    border-radius: 50%;
}

#ui-list.e-listview .hideUI {
    display: none;
}

#ui-list.e-listview .e-list-item {
    padding: 3px 0;
}

#ui-list.e-listview .R {
    background: lightgrey;
}

#ui-list.e-listview .M {
    background: pink;
}

#ui-list.e-listview .A {
    background: lightgreen;
}

#ui-list.e-listview .S {
    background: lightskyblue;
}

#ui-list.e-listview .J {
    background: orange;
}

#ui-list.e-listview .N {
    background: lightblue;
}
<!DOCTYPE html>
<html lang="en">

<head>
    <title>Syncfusion React ListView</title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <meta name="description" content="Essential JS 2 for React Components" />
    <meta name="author" content="Syncfusion" />
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-base/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-react-lists/styles/tailwind3.css" rel="stylesheet" />
    <link href="index.css" rel="stylesheet" />
    <script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.38/system.js"></script>
    <script src="systemjs.config.js"></script>
    <style>
        #loader {
            color: #008cff;
            height: 40px;
            left: 45%;
            position: absolute;
            top: 45%;
            width: 30%;
        }
    </style>
</head>

<body>
    <div id='element' style="margin:0 auto; max-width:400px;">
        <div id='loader'>Loading....</div>
    </div>
</body>

</html>

Conditional rendering

We have also provided following conditional rendering support for template and groupTemplate.

Name Syntax
Conditional class <div class="${ $id % 2 === 0 ? 'even-list' : 'odd-list'}"></div>
Conditional attribute <div id="${ $id % 2 === 0 ? 'even-list' : 'odd-list'}"></div>
Conditional text content <div>${ $id % 2 === 0 ? 'even-list' : 'odd-list'}</div>

In the below sample, we have applied light blue for even list and light coral for odd list based on the conditional class.

import * as React from 'react';
import * as ReactDOM from "react-dom";
import { ListViewComponent, Inject, Virtualization } from '@syncfusion/ej2-react-lists';
function App() {
    // define the array of Json
    let listData;
    listData = [
        { text: "Nancy", id: "0" },
        { text: "Andrew", id: "1" },
        { text: "Janet", id: "2" },
        { text: "Margaret", id: "3" },
        { text: "Steven", id: "4" },
        { text: "Laura", id: "5" },
        { text: "Robert", id: "6" },
        { text: "Michael", id: "7" },
        { text: "Albert", id: "8" },
        { text: "Nolan", id: "9" }
    ];
    for (let i = 10; i <= 1010; i++) {
        let index = parseInt((Math.random() * 10).toString());
        listData.push({ text: listData[index].text, id: i.toString() });
    }
    let template = "<div id=\"list-container\" class=\"class-${parseInt(id) % 2}\" > ${text} </div>";
    return (
        // specifies the tag to render the ListView component
        <ListViewComponent id="ui-list" dataSource={listData} enableVirtualization={true} template={template} height={500}>
            <Inject services={[Virtualization]} />
        </ListViewComponent>);
}
export default App;
ReactDOM.render(<App />, document.getElementById('element'));
import * as React from 'react';
import * as ReactDOM from "react-dom";
import { ListViewComponent, Inject, Virtualization } from '@syncfusion/ej2-react-lists';

function App() {
  // define the array of Json
  let listData: { [key: string]: string | object }[];
  listData = [
    { text: "Nancy", id: "0" },
    { text: "Andrew", id: "1" },
    { text: "Janet", id: "2" },
    { text: "Margaret", id: "3" },
    { text: "Steven", id: "4" },
    { text: "Laura", id: "5" },
    { text: "Robert", id: "6" },
    { text: "Michael", id: "7" },
    { text: "Albert", id: "8" },
    { text: "Nolan", id: "9" }
  ];
  for (let i: number = 10; i <= 1010; i++) {
    let index: number = parseInt((Math.random() * 10).toString());
    listData.push({ text: listData[index].text, id: i.toString() });
  }

  let template: string = "<div id=\"list-container\" class=\"class-${parseInt(id) % 2}\" > ${text} </div>";

  return (
    // specifies the tag to render the ListView component
    <ListViewComponent
      id="ui-list"
      dataSource={listData}
      enableVirtualization={true}
      template={template}
      height={500}
    >
      <Inject services={[Virtualization]} />
    </ListViewComponent>
  );
}
export default App;
ReactDOM.render(<App />, document.getElementById('element'));
#ui-list {
  display: block;
  max-width: 400px;
  margin: auto;
  border: 1px solid #dddddd;
  border-radius: 3px;
  cursor: pointer;
}

#list-container {
  height: inherit;
  width: inherit;
  padding-left: 30px;
}

#ui-list .e-list-item {
  padding: 0;
}

#ui-list .class-0 {
  background-color: #cfd8dc;
}

#ui-list .class-1 {
  background-color: #eceff1;
}
<!DOCTYPE html>
<html lang="en">

<head>
    <title>Syncfusion React ListView</title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <meta name="description" content="Essential JS 2 for React Components" />
    <meta name="author" content="Syncfusion" />
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-base/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-react-lists/styles/tailwind3.css" rel="stylesheet" />
    <link href="index.css" rel="stylesheet" />
    <script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.38/system.js"></script>
    <script src="systemjs.config.js"></script>
    <style>
        #loader {
            color: #008cff;
            height: 40px;
            left: 45%;
            position: absolute;
            top: 45%;
            width: 30%;
        }
    </style>
</head>

<body>
    <div id='element' style="margin:0 auto; max-width:400px;">
        <div id='loader'>Loading....</div>
    </div>
</body>

</html>